import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImageOp;
import java.awt.image.ConvolveOp;
import java.awt.image.Kernel;
import java.util.Arrays;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

import org.jdesktop.jxlayer.JXLayer;
import org.jdesktop.jxlayer.plaf.effect.BufferedImageOpEffect;
import org.jdesktop.jxlayer.plaf.ext.LockableUI;

public class BlurLockSample {
    private LockableUI blurUI;

    public BlurLockSample() {
        JFrame frame = new JFrame("JXLayer Blur Lock Sample");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(300, 120);

        JPanel panel = createPanel();

        // JXLayerIuWFNg̐
        JXLayer<JComponent> layer = new JXLayer<JComponent>(panel);

        // ڂsȂBufferedImageOpIuWFNg
        BufferedImageOp blurOp = createConvolveOp(5);

        // bN\LayerUIłLockableUIgp
        blurUI = new LockableUI(new BufferedImageOpEffect(blurOp));

        layer.setUI(blurUI);

        frame.add(layer, BorderLayout.CENTER);
        frame.add(createCheckBox(), BorderLayout.SOUTH);

        frame.setVisible(true);
    }

    private JPanel createPanel() {
        JPanel panel = new JPanel();
        
        JTextField field = new JTextField(10);
        panel.add(field);

        JButton button = new JButton("Update");
        panel.add(button);

        return panel;
    }

    private ConvolveOp createConvolveOp(int round) {
        float[] data = new float[round*round];
        Arrays.fill(data, (float)1.0/round/round);

        // ڂsȂ߂̃J[l
        // ڂsȂꍇAׂĂ̒l𓯈ɂA
        // ׂĂ̗vf𑫂1ɂȂ悤ɂ
        Kernel kernel = new Kernel(round, round, data);

        // R{[[W(ݍ)sȂIy[V
        ConvolveOp op = new ConvolveOp(kernel);

        return op;
    }

    private JComponent createCheckBox() {
        JPanel panel = new JPanel();

        // bN̗L`FbN`FbN{bNX
        JCheckBox box = new JCheckBox("Lock");
        box.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                JCheckBox box = (JCheckBox)event.getSource();

                if (box.isSelected()) {
                    // `FbNĂAbN
                    blurUI.setLocked(true);
                } else {
                    // `FbNĂȂ΁AbN
                    blurUI.setLocked(false);
                }
            }
        });

        panel.add(box);

        return panel;
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                new BlurLockSample();
            }
        });
    }
}